import { RouteOptions } from './handlers.types';
export declare function defaultRoutes<ResourceType>(): {
    list: RouteOptions<ResourceType, () => {}, 'list'>;
    create: RouteOptions<ResourceType, (data: ResourceType) => {
        body: ResourceType;
    }>;
    get: RouteOptions<ResourceType, (id: string | number) => {
        resourceId: string;
        routeParams: [string];
    }>;
    put: RouteOptions<ResourceType, (id: string | number, data: ResourceType) => {
        resourceId: string;
        routeParams: [string];
        body: ResourceType;
    }>;
    patch: RouteOptions<ResourceType, (id: string | number, data: Partial<ResourceType>) => {
        resourceId: string;
        routeParams: [string];
        body: Partial<ResourceType>;
    }>;
    delete: RouteOptions<ResourceType, (id: string | number) => {
        resourceId: string;
        routeParams: [string];
    }, 'none'>;
};
