import { CacheStore, GetIdFromResource } from './store';
import { RouteMap } from './routes.types';
export declare type Handlers<ResourceType, Routes extends RouteMap<ResourceType>> = {
    [P in keyof Routes]: (...params: Routes[P]['handler'] extends undefined ? [] : Parameters<NonNullable<Routes[P]['handler']>>) => Promise<ReturnType<NonNullable<Routes[P]['parseResponse']>>>;
};
export declare function checkIfValidId(id: string | number): boolean;
export declare function createHandlers<ResourceType extends {
    id: string | number;
}, Routes extends RouteMap<any>>(routes: Routes, getIdFromResource: GetIdFromResource<ResourceType>, store: CacheStore<ResourceType>): Handlers<ResourceType, Routes>;
