import { RouteMap, RouteInheritableOptions, RouteOptions } from './routes.types';
export declare function generateRoutes<ResourceType extends {
    id: string | number;
}, ExtraRoutes extends RouteMap<ResourceType>>(routes: ExtraRoutes, inheritableConfig: RouteInheritableOptions<ResourceType>): {
    list: RouteOptions<ResourceType, () => {}, "list">;
    get: RouteOptions<ResourceType, (id: ResourceType["id"]) => {
        resourceId: ResourceType["id"];
    }, "item">;
    put: RouteOptions<ResourceType, (id: ResourceType["id"], data: ResourceType) => {
        resourceId: ResourceType["id"];
        body: ResourceType;
    }, "item">;
    patch: RouteOptions<ResourceType, (id: ResourceType["id"], data: Partial<ResourceType>) => {
        resourceId: ResourceType["id"];
        body: Partial<ResourceType>;
    }, "item">;
    create: RouteOptions<ResourceType, (data: Pick<ResourceType, import("./utils/types").SetDifference<keyof ResourceType, "id">>) => {
        body: Pick<ResourceType, import("./utils/types").SetDifference<keyof ResourceType, "id">>;
    }, "item">;
    delete: RouteOptions<ResourceType, (id: ResourceType["id"]) => {
        resourceId: ResourceType["id"];
    }, "none">;
} & ExtraRoutes;
