import { RouteMap, RouteInheritableOptions, RouteDataType, RouteData, RouteOptions } from './routes.types';
import { Omit } from '../utils/types';
import { Resource } from '../store';
export declare function createRoute<ResourceType extends Resource, DataType extends RouteDataType, TransformRequestFunc extends (...args: any) => RouteData = () => Record<string, any>>(route: RouteOptions<ResourceType, TransformRequestFunc, DataType>): RouteOptions<ResourceType, TransformRequestFunc, DataType>;
export declare function generateRoutes<ResourceType extends Resource, ExtraRoutes extends RouteMap<ResourceType>>(routes: ExtraRoutes, inheritableConfig: RouteInheritableOptions<ResourceType>): {
    list: RouteOptions<ResourceType, () => Record<any, string>, "list">;
    get: RouteOptions<ResourceType, (id: ResourceType['id']) => {
        resourceId: ResourceType["id"];
    }, "item">;
    put: RouteOptions<ResourceType, (id: ResourceType['id'], data: ResourceType) => {
        resourceId: ResourceType["id"];
        body: ResourceType;
    }, "item">;
    patch: RouteOptions<ResourceType, (id: ResourceType['id'], data: Partial<ResourceType>) => {
        resourceId: ResourceType["id"];
        body: Partial<ResourceType>;
    }, "item">;
    create: RouteOptions<ResourceType, (data: Omit<ResourceType, 'id'>) => {
        body: Omit<ResourceType, "id">;
    }, "item">;
    remove: RouteOptions<ResourceType, (id: ResourceType['id']) => {
        resourceId: ResourceType["id"];
    }, "none">;
} & ExtraRoutes;
