import { RouteDataWithName } from '../routes/routes.types';
export declare type RestApiActionHandlers = {
    update: ReturnType<typeof createActions>['update'];
    updateList: ReturnType<typeof createActions>['updateList'];
    deleteResource: ReturnType<typeof createActions>['deleteResource'];
    clearStore: ReturnType<typeof createActions>['clearStore'];
};
export declare function createActions(resourceName?: string): {
    update: {
        request: (data: {
            routeData?: RouteDataWithName;
            id: string | number;
        }) => {
            type: string;
            payload: {
                routeData?: RouteDataWithName | undefined;
                id: string | number;
            };
        };
        success: (data: {
            routeData?: RouteDataWithName | undefined;
            id: string | number;
            data: any;
        }) => {
            type: string;
            payload: {
                routeData?: RouteDataWithName | undefined;
                id: string | number;
                data: any;
            };
        };
        failure: (data: {
            routeData?: RouteDataWithName;
            error: Error;
            id?: string | number;
        }) => {
            type: string;
            payload: {
                routeData?: RouteDataWithName | undefined;
                error: Error;
                id?: string | number | undefined;
            };
        };
        cancel: (data: {
            routeData?: RouteDataWithName;
        }) => {
            type: string;
            payload: {
                routeData?: RouteDataWithName | undefined;
            };
        };
    };
    updateList: {
        request: (data: {
            routeData?: RouteDataWithName;
        }) => {
            type: string;
            payload: {
                routeData?: RouteDataWithName | undefined;
            };
        };
        success: (data: {
            routeData?: RouteDataWithName | undefined;
            data: Record<string, any>;
        }) => {
            type: string;
            payload: {
                routeData?: RouteDataWithName | undefined;
                data: Record<string, any>;
            };
        };
        failure: (data: {
            routeData?: RouteDataWithName;
            error: Error;
        }) => {
            type: string;
            payload: {
                routeData?: RouteDataWithName | undefined;
                error: Error;
            };
        };
        cancel: (data: {
            routeData?: RouteDataWithName;
        }) => {
            type: string;
            payload: {
                routeData?: RouteDataWithName | undefined;
            };
        };
    };
    deleteResource: (data: {
        routeData?: RouteDataWithName;
        id: string | number;
    }) => {
        type: string;
        payload: {
            routeData?: RouteDataWithName | undefined;
            id: string | number;
        };
    };
    clearStore: () => {
        type: string;
    };
};
