import { RestApiActionHandlers } from './actions';
import { ActionWithPayload } from '../utils/actionTypes';
import { Resource } from './types';
export declare type CacheStoreData<ResourceType extends Resource> = Record<ResourceType['id'], ResourceType>;
export declare type CacheStoreDispatch = (action: ActionWithPayload<any, any>) => void;
export declare type SubscribeCallback<ResourceType extends Resource> = (state: CacheStoreData<ResourceType>, action: ActionWithPayload<any, any>) => void;
export declare type CacheStore<ResourceType extends Resource> = Readonly<{
    dispatch: CacheStoreDispatch;
    getState: () => CacheStoreData<ResourceType>;
    getStoreName: () => string;
    subscribe: (callback: SubscribeCallback<ResourceType>) => string;
    unsubscribe: (subId: string) => boolean;
    actions: RestApiActionHandlers;
    clearStore: () => void;
}>;
export declare type CacheStoreConfig<ResourceType extends Resource> = {
    initialData?: CacheStoreData<ResourceType>;
    partialUpdate?: boolean;
};
export declare function createStore<ResourceType extends Resource>(storeName: string, config: CacheStoreConfig<ResourceType>): CacheStore<ResourceType>;
