import { CacheStoreData, CacheStore } from './createStore';
import { Resource } from './types';
export declare type GetIdFromResource<ResourceType extends Resource> = (data: ResourceType) => ResourceType['id'];
export declare type GetResource<ResourceType extends Resource> = (state: CacheStoreData<ResourceType>, id: ResourceType['id']) => ResourceType;
export declare type Selectors<ResourceType extends Resource> = {
    getResource: GetResource<ResourceType>;
    getIdFromResource: GetIdFromResource<ResourceType>;
};
export declare function createSelectors<ResourceType extends Resource>({ getStoreName, }: CacheStore<ResourceType>): Selectors<ResourceType>;
